#include <csignal>
#include <iomanip>
#include <unistd.h>
#include "../os5-6.h"
//#define SEM
//#define BAR
//#define FIXED
#ifdef SEM
#include <semaphore.h>
#endif
using namespace std;

bool stopThreads(false);
float trapezoidal(float a, float b, unsigned int n) {
    float sum = 0;
    float h = (b - a) / n;
    sum += (f(a) + f(b)) / 2;
    for (int i = 1; i < n; i++) {
        while(stopThreads){}
        float x = a + i * h;
        sum += f(x);
    }
    return sum * h;
}
#ifndef FIXED
vector<unsigned int> t;
#endif
vector<pthread_t> threads;

unsigned short cthreads;
float result = 0;

typedef struct ThreadParams {
    float start;
    float end;
    float* result;
    unsigned int n;
} th_param;
#ifdef SEM
sem_t semaphore;
#endif
#ifdef BAR
pthread_barrier_t barrier;
#endif
void* ThreadFunction(void* args) {
    float local_result = trapezoidal(((th_param*)args)->start, ((th_param*)args)->end, ((th_param*)args)->n);
#ifdef BAR
            pthread_barrier_wait(&barrier);
#endif
#ifdef SEM
            sem_wait(&semaphore);
#endif
            result+=local_result;
#ifdef SEM
            sem_post(&semaphore);
#endif
            delete (th_param*)args;
            return 0;
}

void* displayMenu(void* args) {
    while (true) {
        cin.get();
        stopThreads = true;
        cout << cthreads << " threads were interrupted." << endl;
        display;
        char option;
        cin >> option;
        if (option == '1') {
            stopThreads = false;
            cin.get();
        } else if (option == '2') {
            cout << "Select thread to change priority: ";
            unsigned short thread;
            cin >> thread;
            cout << "Enter new priority";
                    if (getuid())cout << " (may require root privileges)";
                    cout << ": (1-99): " << endl;
            sched_param sch_params;
            cin>>sch_params.sched_priority;
            if (pthread_setschedparam(threads[thread - 1], SCHED_RR, &sch_params) != 0) 
                cerr << "Failed to set priority"<<endl;
             else
                cout << "Changed priority for thread " << threads[thread - 1] << endl;
            
        } else if (option == '3') {
            cout << "Select thread to deatach: ";
            unsigned short thread;
            cin >> thread;
            pthread_detach(threads[thread - 1]);
            cout << "Detached thread " << threads[thread - 1] << endl;
            if (pthread_kill(threads[thread - 1], 0) == ESRCH)
                cout << "Thread is dead after deatach..." << endl;
            else
                cout << "Thread is still alive after deatach..." << endl;
            stopThreads = false;
            cin.get();
          }
            else if (option == '0') {
#ifndef FIXED
            displayinfo;
#endif
            exit(0);
        }
    }
}

int main() {
#ifdef SEM
  sem_init(&semaphore, 0, 1);
#endif
  pthread_t input;
    pthread_create(&input,NULL,displayMenu,NULL);
#ifdef FIXED
#define cthreads num_threads
#else
    for (cthreads = 1; cthreads <= num_threads; cthreads++) {
#endif
#ifdef BAR
        pthread_barrier_init(&barrier, nullptr, cthreads);
#endif
        float per = 100.0 / cthreads;
        float current = 0;
        result = 0;
        threads.clear();
        auto start = chrono::high_resolution_clock::now();

        for (unsigned char i = 0; i < cthreads; i++) {
            float start = current;
            current += per;
            unsigned int n=1000000/cthreads;
            ThreadParams* params = new ThreadParams{start, current, &result, n};

            pthread_t hThread;
            pthread_create(&hThread, 0, ThreadFunction, params);
            if (hThread) {
                threads.push_back(hThread);
            } else {
                cerr << "Failed to create thread " << i + 1 << endl;
                delete params;
            }
        }

        for (pthread_t hThread : threads) {
            pthread_join(hThread, NULL);
        }
#ifdef FIXED
        cout<<"Took "<<chrono::duration_cast<chrono::nanoseconds>(chrono::high_resolution_clock::now() - start).count()<<" nanoseconds for "<<cthreads<<" threads"<<endl;
#else
        t.push_back(chrono::duration_cast<chrono::nanoseconds>(chrono::high_resolution_clock::now() - start).count());
#endif
        if (result<-194&&result>-195)cout<<"Verification passed for "<<cthreads<<"\tthreads... result: "<<setprecision(5)<<result<<endl;
        else {cout<<"Verification failed for "<<cthreads<<" threads!!!"<<endl<<"Got "<<result<<endl;pthread_cancel(input);return 1;}
#ifdef BAR
        pthread_barrier_destroy(&barrier);
#endif
#ifndef FIXED
    }
#endif

    pthread_cancel(input);
#ifndef FIXED
    displayinfo;
#endif
    return 0;
}
